﻿using Microsoft.AspNetCore.Mvc;
using PracMedic.Models;

namespace PracMedic.Controllers
{
    public class AnamnezaController : Controller
    {
        PracMedicContext context = new PracMedicContext();
        private List<Anamneza> anamneza;
        private List<Pacient> pacients;

        public AnamnezaController()
        {
            this.anamneza = this.context.Anamnezas.ToList();
            this.pacients = this.context.Pacients.ToList();
        }

        [HttpGet]
        public IActionResult EditAnamneza(int id)
        {
            Anamneza anamneza = this.context.Anamnezas.Find(id);
            Pacient pacient = this.pacients.Find(x => x.Id == anamneza.Pacient);
            this.ViewBag.dekursId = pacient.Dekurs;
            this.ViewBag.ockovaniId = pacient.Ockovani;

            this.ViewBag.pacientId = anamneza.Pacient;
            return View(anamneza);
        }

        public IActionResult EditAnamneza(Anamneza anamneza1)
        {
            if (this.ModelState.IsValid)
            {
                Anamneza db = this.context.Anamnezas.Find(anamneza1.Id);
                db.OsobniAnamneza = anamneza1.OsobniAnamneza;
                db.RodinnaAnamneza = anamneza1.RodinnaAnamneza;
                db.Odmita = anamneza1.Odmita;
                db.Neockovat = anamneza1.Neockovat;
                db.Gea = anamneza1.Gea;
                db.Vydana = anamneza1.Vydana;
                db.Tat = anamneza1.Tat;
                db.Toks = anamneza1.Toks;
                this.context.SaveChanges();

                return RedirectToAction("Seznam", "SeznamPacientu");
            }
            return View();
        }
    }
}
