﻿using Microsoft.AspNetCore.Mvc;
using PracMedic.Models;

namespace PracMedic.Controllers
{
    public class OckovaniController : Controller
    {
        PracMedicContext context = new PracMedicContext();
        private List<Ockovani> ockovani;
        private List<Pacient> pacients;

        public OckovaniController()
        {
            this.ockovani = this.context.Ockovanis.ToList(); 
            this.pacients = this.context.Pacients.ToList(); 
        }

        [HttpGet] 
        public IActionResult AddOckovani(int pacientId)
        {
            Pacient pacient = this.context.Pacients.Find(pacientId); 
            this.ViewBag.anamnezaId = pacient.Anamneza;
            this.ViewBag.dekursId = pacient.Dekurs;
            this.ViewBag.pacientId = pacient.Id;
            this.ViewBag.ockovanis = this.ockovani.Where(x => x.Pacient == pacient.Id).ToList();
            return View(new Ockovani()); 
        }

        [HttpPost] 
        public IActionResult AddOckovani(Ockovani ockovani)
        {
            
            if (this.ModelState.IsValid)
            {
                this.context.Add(ockovani);
                this.context.SaveChanges(); 

                return RedirectToAction("AddOckovani", "Ockovani", new { pacientId = ockovani.Pacient });
            }
            return View();
        }

        [HttpGet]
        public IActionResult EditOckovani(int id) 
        {
            Ockovani ockovani = this.context.Ockovanis.Find(id); 
            Pacient pacient = this.pacients.Find(x => x.Id == ockovani.Pacient);
            this.ViewBag.pacientId = ockovani.Pacient;
            this.ViewBag.dekursId = pacient.Dekurs;
            this.ViewBag.anamnezaId = pacient.Anamneza;
            this.ViewBag.ockovanis = this.ockovani.Where(x => x.Pacient == pacient.Id).ToList();

            return View(ockovani);
        }

        public IActionResult EditOckovani(Ockovani ockovani1)
        {
            if (this.ModelState.IsValid)
            {               
                Ockovani db = this.context.Ockovanis.Find(ockovani1.Id); 
                db.Nazev = ockovani1.Nazev;
                db.Mnozstvi = ockovani1.Mnozstvi;
                db.TypDavky = ockovani1.TypDavky;
                db.Sarze = ockovani1.Sarze;
                db.Expirace = ockovani1.Expirace;
                db.Onemocneni = ockovani1.Onemocneni;
                db.CestaPodani = ockovani1.CestaPodani;
                db.MistoPodani = ockovani1.MistoPodani;
                db.Poznamka = ockovani1.Poznamka;
                db.datumPodani = ockovani1.datumPodani;

                this.context.SaveChanges(); 

                return RedirectToAction("AddOckovani", "Ockovani", new { pacientId = ockovani1.Pacient });
            }
            return View();
        }
    }
}
