﻿using Microsoft.AspNetCore.Mvc;
using PracMedic.Models;

namespace PracMedic.Controllers
{
    public class PacientController : Controller
    {
        PracMedicContext context = new PracMedicContext();
        private List<Pacient> pacients;
        private List<Dekur> dekurs;
        private List<Anamneza> anamnezas;
        private List<Ockovani> ockovanis;

        public PacientController()
        {
            this.pacients = this.context.Pacients.ToList();
            this.dekurs = this.context.Dekurs.ToList();
            this.anamnezas = this.context.Anamnezas.ToList();
            this.ockovanis = this.context.Ockovanis.ToList();
        }

        public IActionResult Seznam()
        {
            return View();
        }

        public IActionResult Objednani()
        {
            return View();
        }

        public IActionResult Nechopenka()
        {
            return View();
        }

        public IActionResult PacientDelete(int id)
        {
            Pacient pacient = this.context.Pacients.Find(id);
            Dekur dekurs = this.dekurs.Find(x => x.Id == pacient.Dekurs);
            Anamneza anamneza = this.anamnezas.Find(x => x.Id == pacient.Anamneza);
            Ockovani ockovani = this.ockovanis.Find(x => x.Id == pacient.Ockovani);
            pacient.Anamneza = null;
            pacient.Dekurs = null;
            pacient.Ockovani = null;
            this.context.SaveChanges();
            this.context.Remove(pacient);
            this.context.SaveChanges();

            return RedirectToAction("Seznam", "SeznamPacientu");
        }

        [HttpGet]
        public IActionResult EditPacient(int id)
        {
            Pacient pacient = this.context.Pacients.Find(id);

            this.ViewBag.pacientId = pacient.Id; // pro remove btn
            this.ViewBag.dekursId = pacient.Dekurs;
            this.ViewBag.anamnezaId = pacient.Anamneza;
            this.ViewBag.ockovaniId = pacient.Ockovani;
            return View(this.context.Pacients.Find(id));
        }

        public IActionResult EditPacient(Pacient pacient)
        {
            if (this.ModelState.IsValid)
            {
                Pacient db = this.context.Pacients.Find(pacient.Id);
                db.RodneCislo = pacient.RodneCislo;
                db.Jmeno = pacient.Jmeno;
                db.Prijmeni = pacient.Prijmeni;
                db.RodnePrijmeni = db.RodnePrijmeni;
                db.TitulPred = pacient.TitulPred;
                db.TitulZa = pacient.TitulZa;
                db.DatumNarozeni = pacient.DatumNarozeni;
                db.TelCislo = pacient.TelCislo;
                db.Ulice = pacient.Ulice;
                db.CisloPopisne = pacient.CisloPopisne;
                db.Poschodi = pacient.Poschodi;
                db.Mesto = pacient.Mesto;
                db.Psc = pacient.Psc;
                db.Narodnost = pacient.Narodnost;
                db.Pojistovna = pacient.Pojistovna;
                db.PojisteniOd = pacient.PojisteniOd;
                db.RegistrovanOd = pacient.RegistrovanOd;
                db.DruhPece = pacient.DruhPece;
                db.Uprchlik = pacient.Uprchlik;
                db.Poznamka = pacient.Poznamka;
                db.Pohlavi = pacient.Pohlavi;
                db.CisloPrukazu = pacient.CisloPrukazu;
                db.DruhPojisteni = pacient.DruhPojisteni;
                db.Okres = pacient.Okres;
                db.Email = pacient.Email;
                db.NepouzivatEmail = pacient.NepouzivatEmail;
                db.Gdpr = pacient.Gdpr;
                db.Ecp = pacient.Ecp;
                db.Ico = pacient.Ico;
                db.Profese = pacient.Profese;
                db.ZamcisloPopisne = pacient.ZamcisloPopisne;
                db.ZamPsc = pacient.ZamPsc;
                db.Firma = pacient.Firma;
                db.ZamUlice = pacient.ZamUlice;
                db.ZamMesto = pacient.ZamMesto;
                this.context.SaveChanges();

                return RedirectToAction("Seznam", "SeznamPacientu");
            }
            return View();
        }

        [HttpGet]
        public IActionResult AddPacient()
        {
            return View(new Pacient());
        }

        [HttpPost]
        public IActionResult AddPacient(Pacient pacient)
        {
            if (this.ModelState.IsValid)
            {
                Dekur dekurs = new Dekur();
                Anamneza anamneza = new Anamneza();
                Ockovani ockovani = new Ockovani();
                pacient.Dekurs1 = dekurs;
                pacient.AnamnezaNavigation = anamneza;
                pacient.OckovaniNavigation = ockovani;
                this.context.Pacients.Add(pacient);
                this.context.Dekurs.Add(dekurs);
                this.context.Anamnezas.Add(anamneza);
                this.context.Ockovanis.Add(ockovani);
                this.context.SaveChanges();

                Dekur db = this.context.Dekurs.Find(dekurs.Id);
                db.Pacient = pacient.Id;
                Anamneza dbanam = this.context.Anamnezas.Find(anamneza.Id);
                dbanam.Pacient = pacient.Id;
                Ockovani dbocko = this.context.Ockovanis.Find(ockovani.Id);
                dbocko.Pacient = pacient.Id;
                this.context.SaveChanges();

                return RedirectToAction("EditPacient", "Pacient", new { id = pacient.Id });
            }
            return View();
        }
    }
}
