﻿using Microsoft.AspNetCore.Mvc;
using PracMedic.Models;


namespace PracMedic.Controllers
{
    public class SeznamPacientuController : Controller
    {
        PracMedicContext context = new PracMedicContext();
        private List<Pacient> pacients;

        public SeznamPacientuController()
        {
            this.pacients = this.context.Pacients.ToList();
        }

        public IActionResult Seznam(string searchString)
        {
            if (!String.IsNullOrEmpty(searchString))
            {
                IEnumerable<Pacient> pacient = this.pacients.Where(s => (s.Prijmeni != null && s.Prijmeni.Contains(searchString)) 
                || (s.Jmeno != null && s.Jmeno.Contains(searchString)) || (s.RodneCislo != null 
                && s.RodneCislo.Contains(searchString))).ToList();
                return View(pacient.ToList());
            }
            return View(context.Pacients.ToList());
        }
    }
}
